import java.io.*;
import java.net.*;

import yawlservice.*;
import service.*;

public abstract class DeclareServiceServer
    extends Thread {

  private ServerSocket socket = null;
  protected Log log;

  /**
   * RemoteCaseLoader
   *
   * @param port int
   */
  public DeclareServiceServer(int port) {
    super();
    log = new Log("c:\\Documents and Settings\\MPESIC\\Desktop\\declareServiceLog1.txt");
    try {
      socket = new ServerSocket(port);
      log.log("DECLARE SERVER"+"started");
    }
    catch (IOException ex) {
      log.exception(ex);
    }
  }

  public void run() {
    while (true) {
      Socket connection = null;
      try {
        connection = socket.accept();
        log.log("DECLARE connected");
        BufferedReader in = new BufferedReader(new InputStreamReader(new
            BufferedInputStream(connection.
                                getInputStream())));
        PrintWriter out = new PrintWriter(connection.getOutputStream(), true);
        String temp = "";
        String str = "";
        while (! (temp = in.readLine()).equals("")) {
          str += temp;
        }
        YAWLMessage msg = YAWLMessageFactory.parseMessage(str);
        if (msg.requiresResponse()) {
          String response = response(msg);
          out.println(response+'\n');
        }
        else {
          received(msg);
        }
      }
      catch (Exception e) {
        log.exception(e);
        closeConnection(connection);
      }
    }
  }

  public abstract void received(YAWLMessage msg);

  public abstract String response(YAWLMessage msg);

  private void closeConnection(Socket s) {
    try {
      s.close();
    }
    catch (Exception e) {
      // ignore
    }
  }

  protected void finalize() {
    try {
      socket.close();
    }
    catch (IOException e) {
      // ignore
    }

    log.log("Closed the DECLARE server");
  }
}
