import java.io.*;
import java.util.*;
import service.*;

/**
 * <p>Title: TeamWorkFlow</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: TU/e</p>
 *
 * @author Maja Pesic
 * @version 1.0
 */
class AbstractInitializer {

  private final String EQ = "=";
  private final String fileName;
  private final String filePath;
  private Vector<String> vector;

  /**
   * Initializer
   */
   protected AbstractInitializer(String fileName, String path) {
    super();
    this.fileName = fileName;
    this.filePath = (path != null)?path:System.getProperty("user.dir");
    vector = new Vector<String>();
    // ***
    Log log = new Log("C:\\TEAMSERVICE_INI.txt");
    log.log(this.getFileName());
    // ***
    this.readFromFile();
  }

  private String getFileName() {
      if (this.filePath != null)
        return this.filePath + "\\" + fileName;
      else return fileName;
  }

  protected String getValue(String variable) {
    boolean found = false;
    String result = null;
    Iterator<String> iterator = vector.iterator();
    while ( !found && iterator.hasNext() ){
      String line = (String) iterator.next();
      String var = this.variable(line);
      found = var.equals(variable);
      if ( found )
        result = this.value(line);
    }
    return result;
  }
  /**
   *
   * @param line String
   * @return String
   */
  private String variable(String line){
    StringTokenizer st = new StringTokenizer(line,EQ);
    return st.nextToken();
  }
  /**
   *
   * @param line String
   * @return String
   */
  private String value(String line){
    StringTokenizer st = new StringTokenizer(line,EQ);
    st.nextToken();
    return st.nextToken();
  }

  // reads a list of strings from file
  public void readFromFile() {
    BufferedReader infile = null;
    String inLine;
    try {
      // Create a buffered stream
      infile = new BufferedReader(new FileReader(this.getFileName()));

      // Read a line and append the line to the text area

      while ( (inLine = infile.readLine()) != null) {
        vector.add(inLine);
      }
    }
    catch (FileNotFoundException ex) {
      System.out.println("File not found: " + this.getFileName());
    }
    catch (IOException ex) {
      System.out.println(ex.getMessage());
    }
    finally {
      try {
        if (infile != null) infile.close();
      }
      catch (IOException ex) {
        System.out.println(ex.getMessage());
      }
    }
  }
}

public class Initializer
    extends AbstractInitializer {

  private static final String INI_FILE = "teamwork.ini";
  private static final String ENGINE_HOST = "HOST";
  private static final String ENGINE_PORT = "PORT";

  /**
   *
   * @param path String
   */
  public Initializer(String path) {
    super(INI_FILE, path);
  }
  /**
   *
   * @return int
   */
  public int getPort() {
    String value = this.getValue(ENGINE_PORT);
    int port = -1;
    if (value != null) {
      try {
        port = Integer.parseInt(value);
      }
      catch (Exception e) {

      }
    }
    return port;
  }
  /**
   *
   * @return String
   */
  public String getHost() {
    return this.getValue(ENGINE_HOST);
  }

}

