package service;

import java.io.File;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.FileOutputStream;
import java.util.Calendar;
import java.util.GregorianCalendar;

import yawlservice.*;

public class Log{

  

  private PrintToFile p;

  public Log(String fileName) {
    super();
    this.p = new PrintToFile(fileName);
    /*try {
      outputFile = new File(fileName);
      out = new FileOutputStream(outputFile, true);
      p = new PrintStream(out);
    }
    catch (Exception e) {
      e.printStackTrace();
      e.printStackTrace(p);
    }*/
  }
  
  
  public void exception(Exception e){
    log( this.currentTime()+"   "+"EXCEPTION");
    p.exception(e);
  }

  /**
   *
   * @throws Throwable
   */
 // protected void finalize() throws Throwable {  p.close(); }

  /**
   *
   * @param msg String
   */
  public void log(String msg) {
    p.print(msg);
  }

  private void logWorkItem(ExternalWorkItem external){
    org.w3c.dom.Element element = external.toElement();
    String str = XMLParser.toString(element);
    log(str);
  }

  private void logCase(ExternalCase external){
    org.w3c.dom.Element element = external.toElement();
    String str = XMLParser.toString(element);
    log(str);
  }

  /**
   *
   * @param event String
   * @param external ExternalWorkItem
   */
  public void logEvent(String event, ExternalWorkItem external){
    p.print(this.currentTime()+"   "+event);
    this.logWorkItem(external);
  }

  /**
   *
   * @param event String
   * @param external ExternalWorkItem
   */
  public void logCaseEvent(String event, ExternalCase external){
    p.print(this.currentTime()+"   "+event);
    this.logCase(external);
  }

  /**
   *
   * @return String
   */
  private String currentTime(){
  Calendar cal = new GregorianCalendar();

   // Get the components of the time
   int hour24 = cal.get(Calendar.HOUR_OF_DAY);     // 0..23
   int min = cal.get(Calendar.MINUTE);             // 0..59
   int sec = cal.get(Calendar.SECOND);             // 0..59

   final String tsep = ":";
   final String dsep = ":";

   return  Calendar.DAY_OF_MONTH + dsep + Calendar.MONTH + dsep + Calendar.YEAR
           + " " + hour24 + tsep + min + tsep + sec;
  }
  
  private class PrintToFile{
	  
	  private final String fileName;
	  
	  public PrintToFile(String fileName) {
		super();
		this.fileName = fileName;
	}
	  
	  private PrintStream getPrintStream(){
		  File outputFile = null;
		  OutputStream out = null;
		  PrintStream p = null;  
		    try {
		        outputFile = new File(fileName);
		        out = new FileOutputStream(outputFile, true);
		        p = new PrintStream(out);
		      }
		      catch (Exception e) {
		        e.printStackTrace();
		      }
		 return p;     
	  }
	  
	  public void print(String str){
		  PrintStream p = getPrintStream();
		  if (p != null){
			  p.println(str);
			  p.close();
		  }
	  }
	  
	  public void exception(Exception e){
		  PrintStream p = getPrintStream();
		  if (p != null){
			e.printStackTrace(p);
			p.close();
		  }
		  }
  }
}
