package yawlservice;
import java.util.StringTokenizer;


public class YAWLMessageFactory{

 /**
   *
   * @param String str
   * @return Request
   */
  public static YAWLMessage parseMessage(String str){
    StringTokenizer st = new StringTokenizer(str, YAWLMessage.SEPARATOR);
    String TYPE = st.nextToken();

    if (TYPE.equals(WorkItemMessage.TYPE)){ // WorkItemRequest
        String NAME = st.nextToken();
        String wi = st.nextToken();
        ExternalWorkItem workItem = new ExternalWorkItem();
         workItem.fromString(wi);
         if (NAME.equals(StartWorkItemMessage.NAME)) { // StartWorkItemRequest
           return new StartWorkItemMessage(workItem);
         }
         else {
           if (NAME.equals(CompleteWorkItemMessage.NAME)) { // CompleteWorkItemRequest
             return new CompleteWorkItemMessage(workItem);
           }
         }
       } else if (TYPE.equals(CaseMessage.TYPE)){ // CaseRequest
          String NAME = st.nextToken();
          String ec = st.nextToken();
          ExternalCase exCase = new ExternalCase();
          exCase.fromString(ec);
           if (NAME.equals(LaunchCaseMessage.NAME)) { //LaunchCaseRequest
             return new LaunchCaseMessage(exCase);
           }
           else {
             if (NAME.equals(CompleteCaseMessage.NAME)) { //CompleteCaseRequest
               return new CompleteCaseMessage(exCase);
             }
           }
       }

     return null;
  }
}
